// Example Script that demonstrates how to calculate the channel power
//

#include "stdafx.h"
#include "WSAInterface.h"

int _tmain(int argc, _TCHAR* argv[])
{
	
	// The device instance
	int64_t wsaHandle;

	// Device settings
	char ip[20] = "10.126.110.102";
	uint64_t fstart = 2350000000;
	uint64_t fstop = 2450000000;
	uint32_t rbw = 1000;
	char mode[20] = "SH";
	float occupied_percentage = 92.5;
	int32_t attenuator = 0;
	float ref_offset = 0;
	// Variable to hold channel power
	float channel_power = 0;

	// Values to store function results
	int16_t result;
	LPSTR scpi_result;
	
	// connect to device and reset device to default settings
	result = wsaConnect(&wsaHandle, ip);
	result = wsaSetSCPI(wsaHandle, "*RST");
	result = wsaSetSCPI(wsaHandle, ":SYSTEM:ABORT");

	// acquire data read
	scpi_result = wsaGetSCPI(wsaHandle, ":SYSTEM:LOCK:REQUEST? ACQ");
	
	// call the peak find function
	result = wsaChannelPower(wsaHandle, 
					fstart, 
					fstop, 
					rbw,
					mode,
					ref_offset,
					attenuator,
					&channel_power);

	// display the peak power, as well as the frequency location of the peak power
	printf("Channel Power %0.2f MHz\n", (float) channel_power);
		
	result = wsaDisconnect(wsaHandle);
	system("PAUSE");
	return 0;
}

