// Example Script that demonstrates how to use the occupied bandwidth function
//

#include "stdafx.h"
#include "WSAInterface.h"

int _tmain(int argc, _TCHAR* argv[])
{
	
	// The device instance
	int64_t wsaHandle;
	
	// Device settings
	char ip[20] = "10.126.110.102";
	uint64_t fstart = 2350000000;
	uint64_t fstop = 2450000000;
	uint32_t rbw = 1000;
	char mode[20] = "SH";
	float occupied_percentage = 92.5;
	int32_t attenuator = 0;
		
	// Variable to hold occupied bandwidth
	uint64_t occupied_bw = 0;

	// Values to store function results
	int16_t result;
	LPSTR scpi_result;
	
	// connect to device and reset device to default settings
	result = wsaConnect(&wsaHandle, ip);
	result = wsaSetSCPI(wsaHandle, "*RST");
	result = wsaSetSCPI(wsaHandle, ":SYSTEM:ABORT");

	// acquire data read
	scpi_result = wsaGetSCPI(wsaHandle, ":SYSTEM:LOCK:REQUEST? ACQ");
	
	// call the peak find function
	result = wsaOccupiedBandwidth(wsaHandle, 
					fstart, 
					fstop, 
					rbw,
					occupied_percentage,
					mode,
					attenuator,
					&occupied_bw);

	// display the peak power, as well as the frequency location of the peak power
	printf("Occupied Bandwidth %0.2f MHz\n", (float) occupied_bw / 1000000);
		
	result = wsaDisconnect(wsaHandle);
	system("PAUSE");
	return 0;
}

