// Example Script that demonstrates how to control an HDR unit
//

#include "stdafx.h"
#include "WSAInterface.h"

int _tmain(int argc, _TCHAR* argv[])
{
	
	// The device instance
	int64_t wsaHandle;

	// Device settings
	char ip[20] = "10.126.110.120";

	// Values to store function results
	int16_t result;
	LPSTR scpi_result;
	
	// connect to device and reset device to default settings
	result = wsaConnect(&wsaHandle, ip);

	// reset the device
	result = wsaSetSCPI(wsaHandle, "*RST");

	// set the IQ path to connector
	result = wsaSetSCPI(wsaHandle, "OUTPUT:IQ:MODE CONNECTOR");

	// set the attenuation to 20 dB
	result = wsaSetSCPI(wsaHandle, "INPUT:ATT:VAR 20");

	// set the state of the PSFM Gain ( 0,0 =>  Low, 1,0 => Medium, 1,1 => High
	// set to Medium
	result = wsaSetSCPI(wsaHandle, ":INPUT:GAIN 1 1");
	result = wsaSetSCPI(wsaHandle, ":INPUT:GAIN 2 0");


	// set the frequency to 2 GHz
	result = wsaSetSCPI(wsaHandle, "FREQ:CENT 2 GHz");

	// retrieve the IF frequency
	scpi_result = wsaGetSCPI(wsaHandle, "FREQ:IF? -1");
	printf("LO Frequency: %s Hz\n", scpi_result);


	// close connection to device	
	result = wsaDisconnect(wsaHandle);

	return 0;
}

