function [ xAxisPoints lowestFrequency highestFrequency ] = getXAxisPoints(handles)
    

    centerFrequency = 200;
    frequencyScale = getappdata(handles.figure1, 'frequencyScale');
    samplesPerFrame = getappdata(handles.figure1, 'samplesPerFrame');
    bandwidth = getappdata(handles.figure1, 'bandwidth');
    decimationRate = getappdata(handles.figure1, 'decimationRate');

    if isempty(decimationRate) || decimationRate == 0
		scaledBandwidth = double(bandwidth);
	else
		scaledBandwidth = double(bandwidth) / double(decimationRate);
    end
    
    frequencyIncrement = scaledBandwidth / (samplesPerFrame - 1);
    
    if getappdata(handles.figure1, 'isInVeryLowBand')
		lowestFrequency = 0;
		highestFrequency = scaledBandwidth / 2;
    else
        if isempty(centerFrequency)
            scaledCenterFrequency = 0;
        else
            scaledCenterFrequency = double(centerFrequency) / frequencyScale;
        end
        
		lowestFrequency =  scaledCenterFrequency - (scaledBandwidth / 2);
		highestFrequency = scaledCenterFrequency + (scaledBandwidth / 2);
    end
    
    xAxisPoints = lowestFrequency : frequencyIncrement : highestFrequency;
end
