% --- Executes on button press in connectButton.
function handleConnectButton_Callback(hObject, handles)
% hObject    handle to connectButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

setGuiState('frozen', handles);

ipAddress = get(handles.ipAddressTextbox, 'String');

if isempty(ipAddress)
    uicontrol(handles.ipAddressTextbox);
    errordlg('Please enter an IP address');
    setGuiState('disconnected', handles);
    return;
end

wsaHandle = wsaInterface;
[connectResult errorMessage] = wsaHandle.connect(ipAddress);

if connectResult < 0
    displayErrorMessage(errorMessage, connectResult);
    setGuiState('disconnected', handles);
    return;
end

frequencyScale = getappdata(handles.figure1, 'frequencyScale');

setappdata(handles.figure1, 'bandwidth', double(wsaHandle.bandwidth) / frequencyScale);

setappdata(handles.figure1, 'wsaHandle', wsaHandle);


initializeFrequency(handles);
[result errorMessage] = wsaHandle.reset();
[errorCode errorMessage] = wsaHandle.flushData();
setGuiState('connected', handles);
