function handleDecimationTextbox_Callback(hObject, handles)
% hObject    handle to decimationTextbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of decimationTextbox as text
%        str2double(get(hObject,'String')) returns contents of decimationTextbox as a double

    textboxValue = str2double(get(hObject, 'String'));
    minDecimationRate = getappdata(hObject, 'minDecimationRate');
    maxDecimationRate = getappdata(hObject, 'maxDecimationRate');
    
    if isempty(textboxValue) || isnan(textboxValue)
        errordlg('Invalid decimation rate');
        setDecimationTextboxValue(handles, getappdata(handles.figure1, 'lastDecimationRate'));
    elseif (textboxValue ~= 0) && (textboxValue < minDecimationRate || textboxValue > maxDecimationRate)
        errordlg(sprintf('Decimation rate can be 0 or %d to %d', minDecimationRate, maxDecimationRate));
        setDecimationTextboxValue(handles, getappdata(handles.figure1, 'lastDecimationRate'));
    elseif mod(textboxValue, 1)
        errordlg('Decimation rate must be an integer value');
        setDecimationTextboxValue(handles, getappdata(handles.figure1, 'lastDecimationRate'));
    else
        setDecimationTextboxValue(handles, int32(textboxValue));
    end
    
end
