function handleIfGainTextbox_Callback(hObject, handles)
% hObject    handle to ifGainTextbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ifGainTextbox as text
%        str2double(get(hObject,'String')) returns contents of ifGainTextbox as a double

    textboxValue = str2double(get(hObject, 'String'));
    minIfGain = getappdata(hObject, 'minIfGain');
    maxIfGain = getappdata(hObject, 'maxIfGain');
    
    if isempty(textboxValue) || isnan(textboxValue)
        errordlg('Invalid IF gain value');
        setIfGainTextboxValue(handles, getappdata(handles.figure1, 'lastIfGainValue'));
    elseif textboxValue < minIfGain || textboxValue > maxIfGain
        errordlg(sprintf('The IF gain range is %d to %d', minIfGain, maxIfGain));
        setIfGainTextboxValue(handles, getappdata(handles.figure1, 'lastIfGainValue'));
    elseif mod(textboxValue, 1)
        errordlg('IF gain must be an integer value');
        setIfGainTextboxValue(handles, getappdata(handles.figure1, 'lastIfGainValue'));
    else
        setIfGainTextboxValue(handles, int32(textboxValue));
    end
    
end
