% --- Executes on button press in startButton.
function handleStartButton_Callback(~, handles)
% hObject    handle to startButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

setGuiState('frozen', handles);

wsaHandle = getappdata(handles.figure1, 'wsaHandle');
samplesPerFrame = getappdata(handles.figure1, 'samplesPerFrame');
framesPerCapture = getappdata(handles.figure1, 'framesPerCapture');
frequencyScale = getappdata(handles.figure1, 'frequencyScale');

% set the sample size
[wsaResult errorMessage] = wsaHandle.setSamplesPerPacket(framesPerCapture * samplesPerFrame);
if wsaResult < 0
    displayErrorMessage(errorMessage, wsaResult);
    setGuiState('connected', handles);
    return;
end

% set the center frequency
centerFrequency = str2double(get(handles.centerFrequencyEdit, 'String')) * frequencyScale;
[wsaResult errorMessage] = wsaHandle.setFrequency(centerFrequency);
if wsaResult < 0
    displayErrorMessage(errorMessage, wsaResult);
    setGuiState('connected', handles);
    return;
end

% set the attenuator
attenuator = ~(get(handles.attenuatorPopUpMenu, 'Value') - 1);

[wsaResult errorMessage] = wsaHandle.setAttenuator(attenuator);
if wsaResult < 0
    displayErrorMessage(errorMessage, wsaResult);
    setGuiState('connected', handles);
    return;
end


setappdata(handles.figure1, 'isInVeryLowBand', false);

set(handles.startButton, 'userData', 1);
setGuiState('plotting', handles);
handles.initializePlot(handles);

hannWindow = createHannWindow(samplesPerFrame);
plotDataUntilStopped(handles, wsaHandle, hannWindow);
