% --- Executes on button press in stopButton.
function handleStopButton_Callback(hObject, handles)
% hObject    handle to stopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

wsaHandle = getappdata(handles.figure1, 'wsaHandle');
blockCaptureMode = getappdata(handles.figure1, 'blockCaptureMode');
streamCaptureMode = getappdata(handles.figure1, 'streamCaptureMode');
sweepCaptureMode = getappdata(handles.figure1, 'sweepCaptureMode');
setGuiState('frozen', handles);
set(handles.startButton, 'userData', 0);

[errorCode errorMessage captureMode] = wsaHandle.getCaptureMode();

% stop stream mode if the wsa is streaming
if (strcmp(captureMode,streamCaptureMode))
    [wsaResult errorMessage] = wsaHandle.streamStop();
    [errorCode errorMessage] = wsaHandle.flushData();
    [errorCode errorMessage] =  wsaHandle.cleanDataSocket();
    
elseif (strcmp(captureMode,sweepCaptureMode))
    [wsaResult errorMessage] = wsaHandle.sweepStop();
    [errorCode errorMessage] = wsaHandle.flushData();
    [errorCode errorMessage] =  wsaHandle.cleanDataSocket();
    
   
end

% flush remaining data from the socket

setGuiState('connected', handles);