function initialize3dFftHistoryAxis(handles, currentAxis)

    historyLength = getappdata(handles.figure1, 'historyLength');
    minFFTAxis = getappdata(handles.figure1, 'minFFTAxis');
    maxFFTAxis = getappdata(handles.figure1, 'maxFFTAxis');
    fftHistoryData = getappdata(handles.figure1, 'fftHistoryData');
    
    [ xAxisPoints lowestFrequency highestFrequency ] = getXAxisPoints(handles);

    axes(currentAxis);
    plotHandle = surf(xAxisPoints, 1:1:historyLength, fftHistoryData');

    if getappdata(handles.figure1, 'isInVeryLowBand')
        axis(currentAxis, [lowestFrequency highestFrequency 1 historyLength minFFTAxis-10 maxFFTAxis-10 minFFTAxis-10 maxFFTAxis-10]);
    else
        axis(currentAxis, [lowestFrequency highestFrequency 1 historyLength minFFTAxis maxFFTAxis minFFTAxis maxFFTAxis]);
    end
    
    %colormap cool;
    set(gca, 'XGrid', 'off');
    set(gca, 'YGrid', 'off');
    set(gca, 'ZGrid', 'off');
    shading interp;
    
    setappdata(handles.figure1, 'plotHandle3dFftHistory', plotHandle);

end
