function initializeData(handles)

    minFFTAxis = getappdata(handles.figure1, 'minFFTAxis');
    samplesPerFrame = getappdata(handles.figure1, 'samplesPerFrame');
    historyLength = getappdata(handles.figure1, 'historyLength');
    fftHistoryData = getappdata(handles.figure1, 'fftHistoryData');
    
    if getappdata(handles.figure1, 'isInVeryLowBand')
        % Re-initialize the history data only if need to resize:
        if ~isequal(size(fftHistoryData), [(samplesPerFrame / 2) historyLength])
            fftHistoryData = repmat(minFFTAxis, samplesPerFrame / 2, historyLength);
        end
    else
        % Re-initialize the history data only if need to resize:
        if ~isequal(size(fftHistoryData), [samplesPerFrame historyLength])
            fftHistoryData = repmat(minFFTAxis, samplesPerFrame, historyLength);
        end
    end
    
    setappdata(handles.figure1, 'fftHistoryData', fftHistoryData);

    minPowerAxis = getappdata(handles.figure1, 'minPowerAxis');
    powerHistoryLength = getappdata(handles.figure1, 'powerHistoryLength');
    
    powerHistoryData = repmat(minPowerAxis, 1, powerHistoryLength);
    
    setappdata(handles.figure1, 'powerHistoryData', powerHistoryData);
end
