function [fftAxesCopy] = initializeFftAxis(handles, currentAxis)

    samplesPerFrame = getappdata(handles.figure1, 'samplesPerFrame');
    minFFTAxis = getappdata(handles.figure1, 'minFFTAxis');
    maxFFTAxis = getappdata(handles.figure1, 'maxFFTAxis');
    
    [ xAxisPoints lowestFrequency highestFrequency ] = getXAxisPoints(handles);
    
    axes(currentAxis);
    set(gcf, 'DefaultAxesColorOrder', [0 1 0]);
    
    if getappdata(handles.figure1, 'isInVeryLowBand')
        plotHandle = plot(xAxisPoints, zeros(samplesPerFrame / 2, 1), 'LineWidth', 0.1);
        axis(currentAxis, [lowestFrequency highestFrequency minFFTAxis-10 maxFFTAxis-10]);
    else
        plotHandle = plot(xAxisPoints, zeros(samplesPerFrame, 1), 'LineWidth', 0.1);
        axis(currentAxis, [lowestFrequency highestFrequency minFFTAxis maxFFTAxis]);
    end
    
    set(currentAxis,'Color',[0.0 0.0 0.0], 'YGrid', 'on', 'YColor', [0.8 0.8 0.8]);
    fftAxesCopy = copyobj(currentAxis, get(currentAxis, 'parent'));
    set(fftAxesCopy, 'color', 'none', 'xcolor', 'k', 'xgrid', 'off', 'ycolor','k', 'ygrid','off');
    set(fftAxesCopy, 'XTick', []);
    set(fftAxesCopy, 'XTickLabel', []);
    delete(get(fftAxesCopy, 'children'));
    
    shadowAxes = getappdata(handles.figure1, 'shadowAxes');
    shadowAxes.fftAxesCopy = fftAxesCopy;
    setappdata(handles.figure1, 'shadowAxes', shadowAxes);
    
    setappdata(handles.figure1, 'plotHandleFft', plotHandle);
    
end
