function initializeQAxis(handles, currentAxis)

    samplesPerFrame = getappdata(handles.figure1, 'samplesPerFrame');
    minIQAxis = getappdata(handles.figure1, 'minIQAxis');
    maxIQAxis = getappdata(handles.figure1, 'maxIQAxis');
    
    axes(currentAxis);
    set(gcf,'DefaultAxesColorOrder',[1 0 0]);
    plotHandle = plot(zeros(samplesPerFrame, 1), 'LineWidth', 0.1);
    
    axis(currentAxis, [0 samplesPerFrame minIQAxis maxIQAxis]);
    set(currentAxis, 'Color', [0.0 0.0 0.0], 'YGrid', 'off', 'YMinorGrid', 'on', 'YColor', [0.8 0.8 0.8]);
    qAxesCopy = copyobj(currentAxis, get(currentAxis, 'parent'));
    set(qAxesCopy, 'color', 'none', 'xcolor', 'k', 'xgrid', 'off', 'ycolor','k', 'ygrid','off', 'YMinorGrid', 'off');
    delete(get(qAxesCopy, 'children'));
    
    shadowAxes = getappdata(handles.figure1, 'shadowAxes');
    shadowAxes.qAxesCopy = qAxesCopy;
    setappdata(handles.figure1, 'shadowAxes', shadowAxes);
    
    setappdata(handles.figure1, 'plotHandleQ', plotHandle);
    
end
