function labelFrequencyAxis(handles, currentAxis)

    centerFrequency = str2double(get(handles.centerFrequencyTextbox, 'String'));
    samplesPerFrame = getappdata(handles.figure1, 'samplesPerFrame');
    bandwidth = getappdata(handles.figure1, 'bandwidth');

    if getappdata(handles.figure1, 'isInVeryLowBand')
        tickLocations = [1 samplesPerFrame/8 samplesPerFrame/4 samplesPerFrame*0.375 samplesPerFrame/2];
        tickLabels = [0;
            round(bandwidth/8);
            round(bandwidth/4);
            round(bandwidth * 0.375);
            round(bandwidth/2)];
    else
        tickLocations = [1 samplesPerFrame/4 samplesPerFrame/2 samplesPerFrame*0.75 samplesPerFrame];
        tickLabels = [round(centerFrequency - (bandwidth/2));
            round(centerFrequency - (bandwidth/4));
            centerFrequency;
            round(centerFrequency + (bandwidth/4));
            round(centerFrequency + (bandwidth/2))];
    end

    set(currentAxis, 'XTick', tickLocations, 'XTickLabel', tickLabels);

end
