function setGuiState(state, handles)

    if strcmp(state, 'frozen')
        disableAllControls(handles);
    elseif strcmp(state, 'disconnected')
        disconnectedState(handles);
    elseif strcmp(state, 'connected')
        connectedState(handles);
    elseif strcmp(state, 'plotting')
        plottingState(handles);
    else % the 'frozen' state is the default
        disableAllControls(handles);
    end
    
    drawnow;
    
end

function disableAllControls(handles)

    set(handles.connectButton, 'enable', 'off');
    set(handles.disconnectButton, 'enable', 'off');
    set(handles.startButton, 'enable', 'off');
    set(handles.stopButton, 'enable', 'off');
    set(handles.ipAddressTextbox, 'enable', 'off');
    set(handles.averageCheckbox, 'enable', 'off');
    set(handles.attenuatorPopUpMenu, 'enable', 'off');
    set(handles.centerFrequencyEdit, 'enable', 'off');
end

function disconnectedState(handles)

    set(handles.connectButton, 'enable', 'on');
    set(handles.ipAddressTextbox, 'enable', 'on');
    
end

function connectedState(handles)

    set(handles.disconnectButton, 'enable', 'on');
    set(handles.startButton, 'enable', 'on');
    set(handles.averageCheckbox, 'enable', 'on');
    set(handles.attenuatorPopUpMenu, 'enable', 'on');
    set(handles.centerFrequencyEdit, 'enable', 'on');
    
end

function plottingState(handles)

    set(handles.stopButton, 'enable', 'on');
    set(handles.averageCheckbox, 'enable', 'on');
    
end
