function [power_result] = calculateFft(iData, qData, noiseLevelOffset, hannWindow, samplesPerFrame)

    iRemovedDCOffset = (iData - mean(iData));
    qRemovedDCOffset = (qData - mean(qData));

    calibratedQ = calibrateIq(iRemovedDCOffset, qRemovedDCOffset);

    iq = iRemovedDCOffset + 1i * calibratedQ;

    windowedIQ = iq .* hannWindow;
    power_result = (20 * log10((abs(fftshift(fft(windowedIQ)))/length(qData)))) + noiseLevelOffset;

    medianIndex = samplesPerFrame / 2 + 1;
    power_result(medianIndex) = (power_result(medianIndex - 1) + power_result(medianIndex + 1)) / 2;

end