function [calibratedQ] = calibrateIq(iData, qData)

    numberOfSamples = size(iData, 1);

    sumOfSquaresI = sum(iData .^ 2);
    sumOfSquaresQ = sum(qData .^ 2);

    amplitude = sqrt(sumOfSquaresI * 2 / numberOfSamples);
    ratio = sqrt(sumOfSquaresI / sumOfSquaresQ);

    p = (qData / amplitude) * ratio .* (iData / amplitude);

    sinphi = 2 * sum(p) / numberOfSamples;
    phi_est = -asin(sinphi);

    calibratedQ = ((sin(phi_est) * iData) + (ratio * qData)) / cos(phi_est);

end