function constants(hObject)

    setappdata(hObject, 'samplesPerFrame', 1024); % has to be an even number
    setappdata(hObject, 'framesPerCapture', 8);
    setappdata(hObject, 'historyLength', 30);
    setappdata(hObject, 'minIQAxis', -1.2);
    setappdata(hObject, 'maxIQAxis', 1.2);
    setappdata(hObject, 'minFFTAxis', -130);
    setappdata(hObject, 'maxFFTAxis', 0);
    setappdata(hObject, 'bandwidth', 125);
    setappdata(hObject, 'frequencyScale', 1000000);
    setappdata(hObject, 'gainContextIndicator', -2139095040);
    setappdata(hObject, 'frequencyContextIndicator', -2013265920);
    setappdata(hObject, 'referencePointContextIndicator', -1073741824);
    setappdata(hObject, 'referenceLevelIndicator', -2130706432);
    setappdata(hObject, 'blockCaptureMode','BLOCK');
    setappdata(hObject, 'streamCaptureMode','STREAMING');
    setappdata(hObject, 'sweepCaptureMode','SWEEPING');
    
    % Capture mode positions based on selected modes in the capture pop up menu
    setappdata(hObject, 'blockModePosition',1);
    setappdata(hObject, 'streamModePosition',2);
    
    % packet types
    setappdata(hObject, 'dataPacketType',1);
    setappdata(hObject, 'contextPacketType',4);
    setappdata(hObject, 'extensionPacketType',5);

    % "very low band" means 50 MHz and below:
    setappdata(hObject, 'veryLowBandThreshold', 50000000);
    
    setappdata(hObject, 'isInVeryLowBand', false);
    
    % Used as an "undo" value when a user inputs an invalid IF gain:
    setappdata(hObject, 'lastIfGainValue', int32('0'));
    
    % Used as an "undo" value when a user inputs an invalid decimation rate:
    setappdata(hObject, 'lastDecimationRate', int32('1'));
    
    setappdata(hObject, 'shadowAxes', struct());
    setappdata(hObject, 'fftHistoryData', 0);
    
    setappdata(hObject, 'powerHistoryLength', 1000);
    setappdata(hObject, 'minPowerAxis', -120);
    setappdata(hObject, 'maxPowerAxis', -20);
    setappdata(hObject, 'powerHistoryData', 0);

end
