function varargout = wsaMultiDisplay(varargin)
% WSAMULTIDISPLAY MATLAB code for wsaMultiDisplay.fig
%      WSAMULTIDISPLAY, by itself, creates a new WSAMULTIDISPLAY or raises the existing
%      singleton*.
%
%      H = WSAMULTIDISPLAY returns the handle to a new WSAMULTIDISPLAY or the handle to
%      the existing singleton*.
%
%      WSAMULTIDISPLAY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in WSAMULTIDISPLAY.M with the given input arguments.
%
%      WSAMULTIDISPLAY('Property','Value',...) creates a new WSAMULTIDISPLAY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before wsaMultiDisplay_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to wsaMultiDisplay_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help wsaMultiDisplay

% Last Modified by GUIDE v2.5 19-Feb-2014 15:43:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @wsaMultiDisplay_OpeningFcn, ...
    'gui_OutputFcn',  @wsaMultiDisplay_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before wsaMultiDisplay is made visible.
function wsaMultiDisplay_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to wsaMultiDisplay (see VARARGIN)

%Add the required functions
if ~isdeployed
    [mFilePath, ~, ~] = fileparts(mfilename('fullpath'));
    addpath(fullfile(mFilePath, 'gui-implementation'));
    addpath(fullfile(mFilePath, 'signal-processing-implementation'));
    addpath(fullfile(mFilePath, '..\wsa-matlab-api'));
    addpath(fullfile(mFilePath, 'utilities'));
    buildWsaMex();
end

% Choose default command line output for wsaMultiDisplay
handles.output = hObject;
handles.initializePlot = @initializePlot;
handles.updatePlots = @updatePlots;

% Update handles structure
guidata(hObject, handles);

setGuiState('frozen', handles);
constants(hObject);
initializePlot(handles);
setGuiState('disconnected', handles);


% --- Outputs from this function are returned to the command line.
function varargout = wsaMultiDisplay_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
%%
varargout{1} = handles.output;


function initializePlot(handles)

initializeData(handles);

deleteShadowAxes(handles);

initializeIqAxis(handles, handles.axes1);
initializeFftAxis(handles, handles.axes2);
initialize3dFftHistoryAxis(handles, handles.axes3);
initialize2dFftHistoryAxis(handles, handles.axes4);
initializeColorBar(handles, handles.axes5);


function updatePlots(handles, iData, qData, fftData, fftHistoryDataToPlot)
showTimeIQ(handles, iData, qData);
showFFT(handles, fftData);
showFFTHistory3D(handles, fftHistoryDataToPlot);
showFFTHistoryWaterfall(handles, fftHistoryDataToPlot);
drawnow;


function showTimeIQ(handles, iData, qData)
plotHandle = getappdata(handles.figure1, 'plotHandleIq');

set(plotHandle(1), 'Ydata', iData);
set(plotHandle(2), 'Ydata', qData);


function showFFT(handles, fftData)
plotHandle = getappdata(handles.figure1, 'plotHandleFft');

set(plotHandle, 'Ydata', fftData);


function showFFTHistory3D(handles, fftHistoryData)
plotHandle = getappdata(handles.figure1, 'plotHandle3dFftHistory');

set(plotHandle, 'ZData', fftHistoryData);


function showFFTHistoryWaterfall(handles, fftHistoryData)
plotHandle = getappdata(handles.figure1, 'plotHandle2dFftHistory');

set(plotHandle, 'ZData', fftHistoryData);


% --- Executes on selection change in captureModePopUpMenu.
function captureModePopUpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to captureModePopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns captureModePopUpMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from captureModePopUpMenu


% --- Executes during object creation, after setting all properties.
function captureModePopUpMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to captureModePopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function centerFrequencyEdit_Callback(hObject, eventdata, handles)
% hObject    handle to centerFrequencyEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of centerFrequencyEdit as text
%        str2double(get(hObject,'String')) returns contents of centerFrequencyEdit as a double


% --- Executes during object creation, after setting all properties.
function centerFrequencyEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to centerFrequencyEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in attenuatorPopUpMenu.
function attenuatorPopUpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to attenuatorPopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns attenuatorPopUpMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from attenuatorPopUpMenu


% --- Executes during object creation, after setting all properties.
function attenuatorPopUpMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to attenuatorPopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
