function varargout = wsaSingleDisplay(varargin)
% WSASINGLEDISPLAY MATLAB code for wsaSingleDisplay.fig
%      WSASINGLEDISPLAY, by itself, creates a new WSASINGLEDISPLAY or raises the existing
%      singleton*.
%
%      H = WSASINGLEDISPLAY returns the handle to a new WSASINGLEDISPLAY or the handle to
%      the existing singleton*.
%
%      WSASINGLEDISPLAY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in WSASINGLEDISPLAY.M with the given input arguments.
%
%      WSASINGLEDISPLAY('dfProperty','Value',...) creates a new WSASINGLEDISPLAY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before wsaSingleDisplay_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to wsaSingleDisplay_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help wsaSingleDisplay

% Last Modified by GUIDE v2.5 19-Feb-2014 13:59:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @wsaSingleDisplay_OpeningFcn, ...
    'gui_OutputFcn',  @wsaSingleDisplay_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout && nargin && strcmp(varargin{1}, 'dataFromMex')
    [varargout{1:nargout}] = gui_mainfcn(gui_State, 'dataFromMex', 0, varargin{:});
elseif nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before wsaSingleDisplay is made visible.
function wsaSingleDisplay_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to wsaSingleDisplay (see VARARGIN)

if ~isdeployed
    [mFilePath, ~, ~] = fileparts(mfilename('fullpath'));
    addpath(fullfile(mFilePath, 'gui-implementation'));
    addpath(fullfile(mFilePath, 'signal-processing-implementation')); 
    addpath(fullfile(mFilePath, '..\wsa-matlab-api'));
    addpath(fullfile(mFilePath, 'utilities'));
    buildWsaMex();
end

% Choose default command line output for wsaSingleDisplay
handles.output = hObject;
handles.initializePlot = @initializePlot;
handles.updatePlots = @updatePlots;

% Update handles structure
guidata(hObject, handles);

setGuiState('frozen', handles);
constants(hObject);
initializePlot(handles);
setGuiState('disconnected', handles);


% --- Outputs from this function are returned to the command line.
function varargout = wsaSingleDisplay_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in displayPopup.
function displayPopup_Callback(hObject, eventdata, handles)
% hObject    handle to displayPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns displayPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from displayPopup
%%
initializePlot(handles)


function initializePlot(handles)

initializeData(handles);

cla(handles.axes1, 'reset');
deleteShadowAxes(handles);

if get(handles.displayPopup, 'Value') == 1
    initializeFftAxis(handles, handles.axes1);
elseif get(handles.displayPopup, 'Value') == 2
    initializeIAxis(handles, handles.axes1);
elseif get(handles.displayPopup, 'Value') == 3
    initializeQAxis(handles, handles.axes1);
elseif get(handles.displayPopup, 'Value') == 4
    initializeIqAxis(handles, handles.axes1);
elseif get(handles.displayPopup, 'Value') == 5
    initialize3dFftHistoryAxis(handles, handles.axes1);
elseif get(handles.displayPopup, 'Value') == 6
    initialize2dFftHistoryAxis(handles, handles.axes1);
end


function updatePlots(handles, iData, qData, powData, fftHistoryData)

if get(handles.displayPopup, 'Value') == 1
    showFFT(handles, powData);
elseif get(handles.displayPopup, 'Value') == 2
    showTimeI(handles, iData);
elseif get(handles.displayPopup, 'Value') == 3
    showTimeQ(handles, qData);
elseif get(handles.displayPopup, 'Value') == 4
    showTimeIQ(handles, iData, qData);
elseif get(handles.displayPopup, 'Value') == 5
    showFFTHistory3D(handles, fftHistoryData);
elseif get(handles.displayPopup, 'Value') == 6
    showFFTHistoryWaterfall(handles, fftHistoryData);
end

drawnow;


function showTimeI(handles, iData)
plotHandle = getappdata(handles.figure1, 'plotHandleI');

set(plotHandle, 'Ydata', iData);


function showTimeQ(handles, qData)
plotHandle = getappdata(handles.figure1, 'plotHandleQ');

set(plotHandle, 'Ydata', qData);


function showTimeIQ(handles, iData, qData)
plotHandle = getappdata(handles.figure1, 'plotHandleIq');

set(plotHandle(1), 'Ydata', iData);
set(plotHandle(2), 'Ydata', qData);


function showFFT(handles, powData)
plotHandle = getappdata(handles.figure1, 'plotHandleFft');
set(plotHandle, 'Ydata', powData);


function showFFTHistory3D(handles, fftHistoryData)
plotHandle = getappdata(handles.figure1, 'plotHandle3dFftHistory');

set(plotHandle, 'ZData', fftHistoryData);


function showFFTHistoryWaterfall(handles, fftHistoryData)
plotHandle = getappdata(handles.figure1, 'plotHandle2dFftHistory');

set(plotHandle, 'ZData', fftHistoryData);


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on selection change in captureModePopUpMenu.
function captureModePopUpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to captureModePopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns captureModePopUpMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from captureModePopUpMenu


% --- Executes during object creation, after setting all properties.
function captureModePopUpMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to captureModePopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in attenuatorPopUpMenu.
function attenuatorPopUpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to attenuatorPopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns attenuatorPopUpMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from attenuatorPopUpMenu


% --- Executes during object creation, after setting all properties.
function attenuatorPopUpMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to attenuatorPopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in decimationPopUpMenu.
function decimationPopUpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to decimationPopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns decimationPopUpMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from decimationPopUpMenu


% --- Executes during object creation, after setting all properties.
function decimationPopUpMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to decimationPopUpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function centerFrequencyEdit_Callback(hObject, eventdata, handles)
% hObject    handle to centerFrequencyEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of centerFrequencyEdit as text
%        str2double(get(hObject,'String')) returns contents of centerFrequencyEdit as a double


% --- Executes during object creation, after setting all properties.
function centerFrequencyEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to centerFrequencyEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to centerFrequencyEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of centerFrequencyEdit as text
%        str2double(get(hObject,'String')) returns contents of centerFrequencyEdit as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to centerFrequencyEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
